#! /usr/bin/env python
'''
Created on Oct 3, 2012

@author: fliwa
'''

MUS_DIR = '/opt/toshiba/mus/scripts'


import sys
sys.path.append(MUS_DIR) 

from monitorupgrade import TaskMgr
from monitorupgrade import TLog as TLOG
from monitorupgrade import Utils as utils




#==========================================================================================================
# Class App - Wrapper class to our TaskManager
#==========================================================================================================
class App:
    
    def __init__(self):
        print'App Constructed!'
        TLOG.logger.info('App Constructed!')
     
    def run(self):
        print'App::run-Starting MUS App'
        TLOG.logger.info('App::run()-START')
        
        TLOG.logger.info('App::run()-Creating TaskManager Object')
        _tskmgr = TaskMgr.TaskMgr()
        
        TLOG.logger.info('App::run()-Calling TaskMgr::initialize() ')
        _tskmgr.initialize()
        
        #check for elofousb kmp driver module, if present then exit MUS
        #This is for MUS 1.0 only, MUS 1.1 don't need it
        TLOG.logger.info('App::run()-Calling TaskMgr::checkFousb()')
        res = _tskmgr.checkFousb()
        if (res == 0):
            TLOG.logger.info('App::run()- The elofousb KMP Driver is installed...aborting MUS')
            raise IOError,'App::run()- The elofousb KMP Driver is installed...aborting MUS'
            
        #check for elousb.ko patch which has the fw_quirk adjustment, if not present then exit MUS
        #This is to ensure we don't have complications with 'broken firmware' workaround
        TLOG.logger.info('App::run()-Calling TaskMgr::checkEloUsbPatch()')
        res = _tskmgr.checkEloUsbPatch()
        if (res != 0):
            TLOG.logger.info('App::run()-The elousb.ko driver is not patched!...aborting MUS')
            raise IOError,'App::run()-The elousb.ko driver is not patched!...aborting MUS'
             
        TLOG.logger.info('App::run()-Calling TaskMgr::performTasks()')
        stat = _tskmgr.performTasks()
        
        #TaskMgr.cleanUp(_tskmgr.RECOVERY_MODE)
        #TODO: CHECK ALL THIS
        utils.cleanUp(_tskmgr.RECOVERY_MODE)
        
        print'App::run()-END'
        TLOG.logger.info('App::run()-END')
        
        return stat
    
    
    
    